var LOGFILE_NAME = "sonos-controller.log";
var lWarn = {
		logln : function(o) {
		}
	};
	var lInfo = {
		logln : function(o) {
		}
	};

lInfo = new Logger(LOGFILE_NAME);
lWarn = new Logger(LOGFILE_NAME);

Property.setSavedProperty=function (path,value) {
	  Property.setProperty(path, value);
	  Property.setFlag(path, 'ARCHIVE', true);
}

var Utf8 = {
		 
	    // public method for url encoding
	    encode : function (string) {
	        string = string.replace(/\r\n/g,"\n");
	        var utftext = "";
	 
	        for (var n = 0; n < string.length; n++) {
	 
	            var c = string.charCodeAt(n);
	 
	            if (c < 128) {
	                utftext += String.fromCharCode(c);
	            }
	            else if((c > 127) && (c < 2048)) {
	                utftext += String.fromCharCode((c >> 6) | 192);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	            else {
	                utftext += String.fromCharCode((c >> 12) | 224);
	                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	 
	        }
	 
	        return utftext;
	    },
	 
	    // public method for url decoding
	    decode : function (utftext) {
	        var string = "";
	        var i = 0;
	        var c = c1 = c2 = 0;
	 
	        while ( i < utftext.length ) {
	 
	            c = utftext.charCodeAt(i);
	 
	            if (c < 128) {
	                string += String.fromCharCode(c);
	                i++;
	            }
	            else if((c > 191) && (c < 224)) {
	                c2 = utftext.charCodeAt(i+1);
	                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
	                i += 2;
	            }
	            else {
	                c2 = utftext.charCodeAt(i+1);
	                c3 = utftext.charCodeAt(i+2);
	                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
	                i += 3;
	            }
	 
	        }
	 
	        return string;
	    }
	 
	};


function convertOldEntries() {
	return upgradePlayerConnection();
}

function upgradePlayerConnection() {
	var oPlayerIPs=[];
	if (Property.getNode('sonos-players')!=null)
		if (Property.getNode('sonos-players').getChildren()) {
			var oArray=Property.getNode('sonos-players').getChildren();
			for (var iIndex=0;iIndex<oArray.length;iIndex++) {
				if (oArray[iIndex].getChild('ipAddress')!=null)
					oPlayerIPs.push(oArray[iIndex].getChild('ipAddress').getValue());				
			}
			new Event('sonos.player',{actions:'updatePlayerDirect',referenceIPs:JSON.stringify(oPlayerIPs),skipPredefinedCheck:true,concurrenceEvent:'sonos.update',concurrenceEventParameter:'{"actions":"backwartUpdateStep2"}'}).raise();
			return true;
		}
	return false;
}

function encodeMetaData(metaData) {	
	metaData=metaData.replace(/&/g, '&amp;');
	metaData=metaData.replace(/</g, '&lt;');
	metaData=metaData.replace(/>/g, '&gt;');
	metaData=metaData.replace(/"/g, '&quot;');
	metaData=metaData.replace(/'/g, '&apos;');
	return metaData;
}

function updateZoneConnection() {
	if (Property.getNode('sonos-players')!=null)
		if (Property.getNode('sonos-players').getChildren()) {
			var oArray=Property.getNode('sonos-players').getChildren();
			for (var iIndex=0;iIndex<oArray.length;iIndex++) {
				var id=oArray[iIndex].getChild('deviceID').getValue();
				var ip=parseInt("" + oArray[iIndex].getChild('roomID').getValue(),10);
				if (ip!=0)
					new Event('sonos.player',{actions:'setZone',id:id,zoneID:ip}).raise();
				if (oArray[iIndex].getChild('disabled').getValue()=='true') {
					new Event('sonos.player',{actions:'disable',id:'["'+id+'"]'}).raise();
				}
			}
		}
}

var fHail=false;
var fFire=false;
var fAbsent=false;
var fDoorbell=false;
var fPanic=false;
var zoneStarts=[];
var zoneStops=[];

function updateEntry(path,fPreset) {
	lInfo.logln('start ' + path);
	try {
		var oParameterObject={triggers:[],target:{},action:{},conditions:{}};
		var oBaseNode=Property.getNode(path);
		
		oParameterObject.action.restoreAfter=!fPreset;
		lInfo.logln('actiontype ');
		if (oBaseNode.getChild('actionType')!=null) {
			switch(oBaseNode.getChild('actionType').getValue()) {
				case 0:
					if (oBaseNode.getChild('nowSingleUrl')!=null) {
						var fRadio=false;
						if (oBaseNode.getChild('nowSingeIsRadio')!=null)
							if ('' + oBaseNode.getChild('nowSingeIsRadio').getValue()=='true')
								fRadio=true;
						if (oBaseNode.getChild('nowSingleUrl').getValue().indexOf('x-sonosapi-stream')>=0)
							fRadio=true;
						if (fRadio) {
							oParameterObject.action.type='plainRadio';
							oParameterObject.action.contentSrc=escape(oBaseNode.getChild('nowSingleUrl').getValue());
							oParameterObject.action.restoreAfter=false;
							oParameterObject.action.info={
									title:oBaseNode.getChild('nowSingleTitle').getValue()
								};
						} else {
							oParameterObject.action.type='plainSong';
							oParameterObject.action.contentSrc=escape(oBaseNode.getChild('nowSingleUrl').getValue());
							oParameterObject.action.info={
								title:oBaseNode.getChild('nowSingleTitle').getValue(),
								artist:oBaseNode.getChild('nowSingleArtist').getValue()
							};
						}
					} else
					if (oBaseNode.getChild('active-queue') != null){
						oParameterObject.action.type='plainQueue';
						oParameterObject.action.content=[];
						var oQueue=oBaseNode.getChild('active-queue').getChildren();
						for (var iIndex=0;iIndex<oQueue.length;iIndex++) {
							var oObject={
								contentUrl:oQueue[iIndex].getChild('playID').getValue(),
								title:oQueue[iIndex].getChild('title').getValue(),
								pos:oQueue[iIndex].getChild('trackPos').getValue()
							}
							oParameterObject.action.content.push(oObject);
						}
						
					}
						
				break;
				case 1: 
					// playlists
					if (oBaseNode.getChild('playListURL') != null) {
						oParameterObject.action.type='playlist';
						oParameterObject.action.contentSrc=escape(oBaseNode.getChild('playListURL').getValue());
					} else 
					if (oBaseNode.getChild('active-queue') != null){
						oParameterObject.action.type='plainQueue';
						oParameterObject.action.content=[];
						var oQueue=oBaseNode.getChild('active-queue').getChildren();
						for (var iIndex=0;iIndex<oQueue.length;iIndex++) {
							var oObject={
								contentUrl:oQueue[iIndex].getChild('playID').getValue(),
								title:oQueue[iIndex].getChild('title').getValue(),
								pos:oQueue[iIndex].getChild('trackPos').getValue()
							}
							oParameterObject.action.content.push(oObject);
						}
						
					}
				break;
				case 2:
					// favorite
					oParameterObject.action.type='favorite';
					lInfo.logln(oBaseNode.getChild('favoritesURL').getValue());
					oParameterObject.action.contentSrc=escape(oBaseNode.getChild('favoritesURL').getValue());
					oParameterObject.action.metaData=encodeMetaData(escape(oBaseNode.getChild('metaData').getValue()));
				break;
				case 3:
					// library
					oParameterObject.action.type='library';
					oParameterObject.action.contentSrc=escape(oBaseNode.getChild('nowSingleUrl').getValue());
					oParameterObject.action.guid=oBaseNode.getChild('mediaFileGUID').getValue();
				break;
				case 4:
					// t2speech
					oParameterObject.action.type='text2speech';
					oParameterObject.action.contentSrc=escape(oBaseNode.getChild('nowSingleUrl').getValue());
					oParameterObject.action.guid=oBaseNode.getChild('t2Sguid').getValue();
					lInfo.logln(oBaseNode.getChild('t2Stext').getValue());
					oParameterObject.action.textUtf=oBaseNode.getChild('t2Stext').getValue().replace(/\u000a/g," ");
					oParameterObject.action.voice_id=oBaseNode.getChild('t2SvoiceID').getValue();
				break;
				case 5:
					//commands 
					oParameterObject.action.type='command';
					switch (parseInt('' + oBaseNode.getChild('command').getValue(),10)) {
						case 1:
							oParameterObject.action.command='stop';
						break;
						case 2:
							oParameterObject.action.command='play';
						break;
						case 3:
							oParameterObject.action.command='pause';
						break;
						case 4:
							oParameterObject.action.command='mute';
						break;
						case 5:
							oParameterObject.action.command='unmute';
						break;
						case 6:
							lInfo.logln('volume up not supported');
							return;
						break;
						case 7:
							lInfo.logln('volume up not supported');
							return;
						break;
					}
				break;
				default:
					lInfo.logln("can't convert " + oBaseNode.getPath());
				break;
			}
		}
		lInfo.logln('volume');
		
		if (oBaseNode.getChild('volumeSet')!=null) {
			if ("" + oBaseNode.getChild('volumeSet').getValue()=='true')
				if (oBaseNode.getChild('volume')!=null) {
					oParameterObject.action.volume=parseInt(''+ oBaseNode.getChild('volume').getValue(),10);
				}	
		}
	
		if (oBaseNode.getChild('setRepeat')!=null) {
			if ("" + oBaseNode.getChild('setRepeat').getValue()=='true')
				if (oBaseNode.getChild('repeatTime')!=null) {
					oParameterObject.action.loopingTimespan=parseInt('' + oBaseNode.getChild('repeatTime').getValue(),10) * 60;
				}	
		}
	
		if (oBaseNode.getChild('restartAfter')!=null) {
			if ("" + oBaseNode.getChild('restartAfter').getValue()=='true')
				oParameterObject.action.restartAfter=true;
		}
		// restart after
		// restore after
		
		lInfo.logln('target');
		if ((oBaseNode.getChild('allRooms')!=null) && (oBaseNode.getChild('allRooms').getValue()==1)) {
			if (oBaseNode.getChild('createSonosGroup').getValue()=="true")
				oParameterObject.target.grouped=[0];
			else
				oParameterObject.target.singularyZone=[0];
		} else {
			if (oBaseNode.getChild('roomID')!=null)
				oParameterObject.target.singularyZone=[oBaseNode.getChild('roomID').getValue()];
			else {
				if (oBaseNode.getChild('pickedRooms')!=null) {
					var sPickedRooms=oBaseNode.getChild('pickedRooms').getValue();
					var oPickedRooms=sPickedRooms.split(';');
					var aPickedRooms=[];
					for (var iIndex=0;iIndex<oPickedRooms.length;iIndex++)
						aPickedRooms.push(parseInt(oPickedRooms[iIndex],10));
					if (oBaseNode.getChild('createSonosGroup').getValue()=="true")
						oParameterObject.target.grouped=aPickedRooms;
					else
						oParameterObject.target.singularyZone=aPickedRooms;
					
				}
			}
				
		}
				
		lInfo.logln('trigger');
		
		var oBaseTriggers=oBaseNode.getChild('triggers').getChildren();
		for (var iIndex=0;iIndex<oBaseTriggers.length;iIndex++) {
			var oObject={};
			var oTriggerNodeArray=oBaseTriggers[iIndex].getChildren();
			for (var jIndex=0;jIndex<oTriggerNodeArray.length;jIndex++)
				oObject[oTriggerNodeArray[jIndex].getName()]=oTriggerNodeArray[jIndex].getValue();
			oParameterObject.triggers.push(oObject);
		}
		
		lInfo.logln('check if prefined (candidate)');
		
		for (var iIndex=0;iIndex<oParameterObject.triggers.length;iIndex++) {
			if ((oParameterObject.triggers[iIndex].type=='zone-scene') || (oParameterObject.triggers[iIndex].type=='bus-zone-scene'))
				if (oParameterObject.triggers[iIndex].zone!=null)
					if (oParameterObject.triggers[iIndex].group!=null)
						if (oParameterObject.triggers[iIndex].scene!=null)
							{
								var zone=oParameterObject.triggers[iIndex].zone;
								var group=oParameterObject.triggers[iIndex].group;
								var scene=oParameterObject.triggers[iIndex].scene;
								if ([5,33,35,37,39].indexOf(scene)>=0) {
									if (zone!=0)
										if (zoneStarts.indexOf(zone)<0) {
											oParameterObject.metaData = '{"zone":'+zone+',"type":"predefinedStartEntry"}';
											zoneStarts.push(zone);
										}
								} else if ([0,32,34,36,38].indexOf(scene)>=0) {
									if (zone!=0)
										if (zoneStops.indexOf(zone)<0) {
											oParameterObject.metaData = '{"zone":'+zone+',"type":"predefinedStopEntry"}';	
											zoneStops.push(zone);
										}
								} else if (zone==0)
									if (group==0) {
										if (scene==72)
											if (!fAbsent) {
												oParameterObject.metaData = '{"type":"predefinedAbsent"}';
												fAbsend=true;
											}
										if (scene==65)
											if (!fPanic) {
												oParameterObject.metaData = '{"type":"predefinedPanic"}';
												fPanic=true;
											}
										if (scene==73) 
											if (!fDoorbell) {
												oParameterObject.metaData = '{"type":"predefinedDoorbell"}';
												fDoorbell=true;
											}
									}
							}
			if (oParameterObject.triggers[iIndex].type=='state-change') {
				if (oParameterObject.triggers[iIndex].name=='hail') {
					if (oParameterObject.triggers[iIndex].state=='inactive') {
						oParameterObject.metaData = '{"type":"predefinedHail","visibility":false}';
					}
					if (oParameterObject.triggers[iIndex].state=='active') {
						if (!fHail) {
							fHail=true;
							oParameterObject.metaData = '{"type":"predefinedHail"}';
						}
					}				
				}
				if (oParameterObject.triggers[iIndex].name=='fire') {
					if (oParameterObject.triggers[iIndex].state=='active') {
						if (!fFire) {
							fFire=true;
							oParameterObject.metaData = '{"type":"predefinedFire"}';
							oParameterObject.implicitRestore = true;
						}
					}				
				}
			}
				
		}


		lInfo.logln('condies enabled' + oBaseNode.getChild('conditions/enabled').getValue());
		lInfo.logln('condies disabled prop' + oBaseNode.getChild('disabled').getValue());
		oParameterObject.conditions.enabled=true;
		if (oBaseNode.getChild('disabled')!=null)
			oParameterObject.conditions.enabled=(""+oBaseNode.getChild('disabled').getValue()!='true');
		else
			if (oBaseNode.getChild('conditions/enabled').getValue()) 
				oParameterObject.conditions.enabled=true;
			else
				oParameterObject.conditions.enabled=false;
		lInfo.logln('PATH : ' + path + '\n' + JSON.stringify(oParameterObject));
		new Event('sonos.config',{actions:'save',value:JSON.stringify(oParameterObject)}).raise();
	} 
	catch (e) {
		lWarn.logln('Error on ' + path + ' with ' + e);
	}
}

function updateSonosActivities() {
	lInfo.logln('updateSonosActivities');
	if (Property.getNode('sonos-activities')!=null)
		if (Property.getNode('sonos-activities').getChildren()!=null) { 
			var oArray=Property.getNode('sonos-activities').getChildren();
			for (var iIndex=0;iIndex<oArray.length;iIndex++) {
				var fSkip=false;
				lInfo.logln('update ' + oArray[iIndex].getPath());
				if (oArray[iIndex].getChild('predefined')!=null)
					if (oArray[iIndex].getChild('predefined').getValue()=='true')
						fSkip=true;
				if (!fSkip)
					updateEntry(oArray[iIndex].getPath(),false);
				else
					lInfo.logln('skipping, because it predefined');
			}
		}	
}

function updateSonosPresets() {
	lInfo.logln('updateSonosPresets');
	if (Property.getNode('sonos-presets')!=null)
		if (Property.getNode('sonos-presets').getChildren()!=null) {
			var oArray=Property.getNode('sonos-presets').getChildren();
			for (var iIndex=0;iIndex<oArray.length;iIndex++) {
				lInfo.logln('update ' + oArray[iIndex].getPath());
				updateEntry(oArray[iIndex].getPath(),true);
			}
		}
}

function cleanUp() {
	lInfo.logln('deleteing the old schmackes');
	var baseNode=Property.getNode('/scripts/sonos-controller');
	var fStore=false;
	if (baseNode.getChild('sonos-presets')!=null) {
		baseNode.removeChild('sonos-presets');
		fStore=true;
	}
	if (baseNode.getChild('sonos-players')!=null) {
		baseNode.removeChild('sonos-players');
		fStore=true;
	}
	if (baseNode.getChild('sonos-selected-preset')!=null) {
		baseNode.removeChild('sonos-selected-preset');
		fStore=true;
	}
	if (baseNode.getChild('sonos-predifined')!=null) {
		baseNode.removeChild('sonos-predifined');
		fStore=true;
	}
	if (baseNode.getChild('sonos-activities')!=null) {
		baseNode.removeChild('sonos-activities');
		fStore=true;
	}
	if (fStore)
		Property.store();
}

function fillBroadcastTrigger(path) {
	lInfo.logln('check path ' + path);
	if (Property.getNode(path+'/triggers')==null)
		return false;
	var fShouldSave=false;
	var oTriggerArray=Property.getNode(path+'/triggers').getChildren();
	for (var iIndex=0;iIndex<oTriggerArray.length;iIndex++) {
		var oTriggerNode=oTriggerArray[iIndex];
		if ((oTriggerNode.getChild('type').getValue()=='zone-scene') || (oTriggerNode.getChild('type').getValue()=='bus-zone-scene')) {
			var zoneID=oTriggerNode.getChild('zone').getValue();
			var groupID=oTriggerNode.getChild('group').getValue();
			var sceneID=oTriggerNode.getChild('scene').getValue();
			if (zoneID!=0)
				if (groupID==4) {
					lInfo.logln('found a preset trigger ... now searching if coresponding broadcast triggers are present');
					var fGroupBroadcast=false;
					var fZoneBroadcast=false;
					var fZoneAndGroupBrodcast=false;
					var iID=0;
					for (var jIndex=0;jIndex<oTriggerArray.length;jIndex++) {
						var oTriggerBroadNode=oTriggerArray[jIndex];
						if ((oTriggerBroadNode.getChild('type').getValue()=='zone-scene') || (oTriggerBroadNode.getChild('type').getValue()=='bus-zone-scene')) {
							if (oTriggerBroadNode.getChild('scene').getValue()==sceneID) {
								var zoneBroadID=oTriggerBroadNode.getChild('zone').getValue();
								var groupBroadID=oTriggerBroadNode.getChild('group').getValue();
								if (zoneBroadID==0) {									
									if (groupBroadID==0)
										fZoneAndGroupBrodcast=true;
									else
										fZoneBroadcast=true;
								} else
									if (groupBroadID==0)
										fGroupBroadcast=true;
							}
						}
						if (parseInt("" + oTriggerBroadNode.getName(),10)>iID)
							iID=parseInt("" + oTriggerBroadNode.getName(),10);
					}
					if (!fGroupBroadcast) {
						lInfo.logln('broadcast trigger is missing for group = 0, zone <> 0 for ' + path);
						iID+=1;
						Property.setSavedProperty(path+'/triggers/' + iID + '/type','zone-scene');
						Property.setSavedProperty(path+'/triggers/' + iID + '/zone',zoneID);
						Property.setSavedProperty(path+'/triggers/' + iID + '/group',0);
						Property.setSavedProperty(path+'/triggers/' + iID + '/scene',sceneID);
						Property.setSavedProperty(path+'/triggers/' + iID + '/dsuid',-1);
						fShouldSave=true;
					}
					if (!fZoneBroadcast) {
						lInfo.logln('broadcast trigger is missing for group <> 0, zone = 0 for ' + path);
						iID+=1;
						Property.setSavedProperty(path+'/triggers/' + iID + '/type','zone-scene');
						Property.setSavedProperty(path+'/triggers/' + iID + '/zone',0);
						Property.setSavedProperty(path+'/triggers/' + iID + '/group',groupID);
						Property.setSavedProperty(path+'/triggers/' + iID + '/scene',sceneID);
						Property.setSavedProperty(path+'/triggers/' + iID + '/dsuid',-1);
						fShouldSave=true;
					}
					if (!fZoneAndGroupBrodcast) {
						lInfo.logln('broadcast trigger is missing for group = 0, zone = 0 for ' + path);
						iID+=1;
						Property.setSavedProperty(path+'/triggers/' + iID + '/type','zone-scene');
						Property.setSavedProperty(path+'/triggers/' + iID + '/zone',0);
						Property.setSavedProperty(path+'/triggers/' + iID + '/group',0);
						Property.setSavedProperty(path+'/triggers/' + iID + '/scene',sceneID);
						Property.setSavedProperty(path+'/triggers/' + iID + '/dsuid',-1);
						fShouldSave=true;
					}
				}
		}
	}
	
	return fShouldSave;	
	

}

function ensureBroadcastTrigger() {
	if (Property.getNode('entries')==null)
		return;
	var oEntries=Property.getNode('entries').getChildren();
	var fSave=false;
	for (var iIndex=0;iIndex<oEntries.length;iIndex++) {
		fSave |= fillBroadcastTrigger(oEntries[iIndex].getPath());
	}
	if (fSave)
		Property.store();
}

function updatePresets() {
	var fStore=false;
	if (Property.getNode('entries')==null)
		return;
	var oArray=Property.getNode('entries').getChildren();
	var oPresets=[5,33,35,37,39,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31];
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
		var oEntryNode=oArray[iIndex];
		lInfo.logln('checking node' + oEntryNode.getPath());
		if (oEntryNode.getChild('triggers')!=null) {
			var oTriggerArray=oEntryNode.getChild('triggers').getChildren();
			for (var jIndex=0;jIndex<oTriggerArray.length;jIndex++) {
				lInfo.logln('checking trigger' + oTriggerArray[jIndex].getPath());
				if (oTriggerArray[jIndex].getChild('type').getValue()=='bus-zone-scene') {
					var iScene=parseInt("" + oTriggerArray[jIndex].getChild('scene').getValue(),10)
					if (oPresets.indexOf(iScene)>=0) {
						Property.setProperty(oTriggerArray[jIndex].getChild('type').getPath(),'zone-scene');
						fStore=true;
					}
				}
			}
		}
	}
	if (fStore)
		Property.store();
}

if (raisedEvent.parameter.actions!=null) {
	if (raisedEvent.parameter.actions=='ensureBroadcastTrigger') {
		ensureBroadcastTrigger();
	}
	if (raisedEvent.parameter.actions=='backwartUpdateStep2') {
		lInfo.logln('backwartUpdateStep2');
		updateSonosActivities();
		new Event('sonos.update',{actions:'backwartUpdateStep3'}).raise();
	}
	if (raisedEvent.parameter.actions=='backwartUpdateStep3') {
		lInfo.logln('backwartUpdateStep3');		
		updateSonosPresets();
		updateZoneConnection();
		new Event('sonos.cloud',{actions:'startup'}).raise();
		new Event('sonos.info',{actions:'fetchSonosPlaylists'}).raise();
		new Event('sonos.info',{actions:'fetchSonosFavorites'}).raise();
		new Event('sonos.player',{actions:'updateZoneConnectedDevices'}).raise();
		new Event('sonos.update',{actions:'updateEntries'}).raise();
	}
	if (raisedEvent.parameter.actions=='startup') {
		Property.load();
		if (!convertOldEntries()) {
			new Event('sonos.config',{actions:'ensurePredefinedEntries'}).raise();
			new Event('sonos.cloud',{actions:'startup'}).raise();		
			new Event('sonos.info',{actions:'fetchSonosPlaylists'}).raise();
			new Event('sonos.info',{actions:'fetchSonosFavorites'}).raise();
			new Event('sonos.player',{actions:'updateZoneConnectedDevices'}).raise();
			new Event('sonos.update',{actions:'ensureBroadcastTrigger'}).raise();
			updatePresets();		
		}
	}
	if (raisedEvent.parameter.actions=='mainteance') {
		new Event('sonos.player',{actions:'updatePlayer'}).raise();
		new Event('sonos.info',{actions:'fetchSonosPlaylists'}).raise();
		new Event('sonos.info',{actions:'fetchSonosFavorites'}).raise();
		new Event('sonos.cloud',{actions:'startMultilanguageSpeechLibrary'}).raise();
	}
	if (raisedEvent.parameter.actions=='updateEntries') {
		lInfo.logln('updateEntries');
		new Event('sonos.config',{actions:'ensurePredefinedEntries'}).raise();
		new Event('sonos.update',{actions:'ensureBroadcastTrigger'}).raise();
		new Event('sonos.player',{actions:'cleanupPlaylists'}).raise();
		cleanUp();
	}	
}

