/**
 * get a property string value from property tree.
 * @param sProp [in] property path
 * @return property value, null if not found
*/
function getPropertyString(sProp)
{
    var sURL='/json/property/getString';
    var sPfad=escape(sProp);
    var sReturn=dss.ajaxSyncRequest(sURL,{'path':sPfad});
    var obj=eval('('+sReturn+')');
    if (obj.ok) {
        return obj.result.value;
    } else {
        return null;
    }
};

/**
 * Check if an IP address is valid.
 * @param sIpAddress [in] ip address
 * @param privateAddress [in] checking if ip is in private space
 * @return true if ip address is valid
*/
function isIpAddressValid(sIpAddress, privateAddress) {
    var ipArray = sIpAddress.match(/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/);
    if (ipArray == null)
        return false;
    
    for (i = 1; i <= 4; i++) {
        if (parseInt(ipArray[i]) > 255)
            return false;
    }
    
    /* private address space
    10.0.0.0        -   10.255.255.255
    172.16.0.0      -   172.31.255.255
    192.168.0.0     -   192.168.255.255
    */
    if (privateAddress) {
        var part1 = parseInt(ipArray[1]);
        var part2 = parseInt(ipArray[2]);
        
        if (part1 === 10) {
            return true;    // valid class A network
        }
        else if ((part1 === 172) && (part2 >= 16) && (part2 <= 31)) {
            return true;    // valid class B network
        }
        else if ((part1 === 192) && (part2 === 168)) {
            return true;    // valid class C network
        }
        return false;
    }

    return true;             
}
